type ('a, 'b) prod =
| Pair of 'a * 'b

(** val fst : ('a1, 'a2) prod -> 'a1 **)

let fst = function
| Pair (x, y) -> x

(** val snd : ('a1, 'a2) prod -> 'a2 **)

let snd = function
| Pair (x, y) -> y

(** val add_v2 :
    ('a1 -> 'a1 -> 'a1) -> ('a1, 'a1) prod -> ('a1, 'a1) prod -> ('a1, 'a1)
    prod **)

let add_v2 add u v =
  Pair ((add (fst u) (fst v)), (add (snd u) (snd v)))

(** val mul_v2 :
    ('a1 -> 'a1 -> 'a1) -> 'a1 -> ('a1, 'a1) prod -> ('a1, 'a1) prod **)

let mul_v2 mul c u =
  Pair ((mul c (fst u)), (mul c (snd u)))

